# Widgets

To build a data widget with CARTO, you need:

* **A data source:** The data for your widget and layers. It contains the authentication, connection details and location for the data in your cloud data warehouse. Learn more about [Data Sources](/carto-for-developers/reference/carto-widgets-reference/data-sources.md).
  * Depending on the data source you're using, the widget will use *server-side calculations* (fully powered by your Data Warehouse) or *client-side calculations* (powered by the user's device after querying your Data Warehouse). Learn more about [Server-side vs client-side](/carto-for-developers/reference/carto-widgets-reference/server-side-vs.-client-side.md).
* **A data model:**
  * [getFormula](/carto-for-developers/reference/carto-widgets-reference/models/getformula.md)
  * [getCategories](/carto-for-developers/reference/carto-widgets-reference/models/getcategories.md)
  * [getHistogram](/carto-for-developers/reference/carto-widgets-reference/models/gethistogram.md)
  * [getRange](/carto-for-developers/reference/carto-widgets-reference/models/getrange.md)
  * [getScatter](/carto-for-developers/reference/carto-widgets-reference/models/getscatter.md)
  * [getTimeSeries](/carto-for-developers/reference/carto-widgets-reference/models/gettimeseries.md)
  * [getTable](/carto-for-developers/reference/carto-widgets-reference/models/gettable.md)
* Optionally, **filters.**
  * [Column-based filters](/carto-for-developers/reference/filters/column-filters.md)
  * [Spatial filters](/carto-for-developers/reference/filters/spatial-filters.md)

Additionally, you'll need:

* **A UI of your choice:** use a completely custom HTML component or integrate your favorite charting library. Many of our examples use [Apache ECharts](https://echarts.apache.org/en/index.html), but you can choose and customize your favorite library or component.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.carto.com/carto-for-developers/reference/carto-widgets-reference.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
